SystemOrganization addCategory: #'CodA-Kernel'!
SystemOrganization addCategory: #'CodA-Tests'!

!ClassBuilder methodsFor: '*CodA' stamp: 'je 12/5/2007 16:03'!
newAnonymSubclassOf: newSuper type: type instanceVariables: instVars from: oldClass
	"Create a new subclass of the given superclass with the given specification."
	"WARNING: This method does not preserve the superclass/subclass invariant!!"
	| newFormat newClass |
	"Compute the format of the new class"
	newFormat := 
		self computeFormat: type 
			instSize: instVars size 
			forSuper: newSuper 
			ccIndex: (oldClass ifNil:[0] ifNotNil:[oldClass indexIfCompact]).

	newFormat == nil ifTrue:[^nil].

	(oldClass == nil or:[oldClass isMeta not]) 
		ifTrue:[newClass := self privateNewSubclassOf: newSuper from: oldClass]
		ifFalse:[newClass := oldClass clone].

	newClass 
		superclass: newSuper
		methodDictionary: MethodDictionary new
		format: newFormat;
		setInstVarNames: instVars.

	oldClass ifNotNil:[
		newClass organization: oldClass organization.
		"Recompile the new class"
		oldClass hasMethods 
			ifTrue:[newClass compileAllFrom: oldClass].

		oldClass hasTraitComposition ifTrue: [
			newClass setTraitComposition: oldClass traitComposition copyTraitExpression ].
		oldClass class hasTraitComposition ifTrue: [
			newClass class setTraitComposition: oldClass class traitComposition copyTraitExpression ].
		
		self recordClass: oldClass replacedBy: newClass.
	].

	^newClass! !

Object subclass: #CodAAnonymClass
	instanceVariableNames: 'meta baseClass'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodA-Kernel'!

CodAAnonymClass class
	instanceVariableNames: 'meta'!

CodAAnonymClass class
	instanceVariableNames: 'meta'!

!CodAAnonymClass class methodsFor: 'as yet unclassified' stamp: 'mab 1/25/2008 16:32'!
doesNotUnderstand: aMessage
	^self meta oldObject class perform: aMessage selector withArguments: aMessage arguments! !

!CodAAnonymClass class methodsFor: 'as yet unclassified' stamp: 'je 1/18/2008 19:05'!
meta
	^meta! !

!CodAAnonymClass class methodsFor: 'as yet unclassified' stamp: 'je 1/18/2008 19:05'!
meta: anObject
	meta := anObject! !

!CodAAnonymClass class methodsFor: 'as yet unclassified' stamp: 'mab 1/22/2008 11:24'!
withArgs: argArray executeMethod: compiledMethod
	"Execute compiledMethod against the receiver and args in argArray"

	| selector |
	<primitive: 188>
	selector := Symbol new.
	self class addSelectorSilently: selector withMethod: compiledMethod.
	^ [self perform: selector withArguments: argArray]
		ensure: [self class basicRemoveSelector: selector]! !

!CodAAnonymClass methodsFor: 'accessing' stamp: 'je 1/18/2008 18:26'!
baseClass
	^ baseClass! !

!CodAAnonymClass methodsFor: 'accessing' stamp: 'je 1/18/2008 18:26'!
baseClass: anObject
	baseClass := anObject! !

!CodAAnonymClass methodsFor: 'as yet unclassified' stamp: 'je 1/18/2008 17:48'!
class
	^self baseClass! !

!CodAAnonymClass methodsFor: 'as yet unclassified' stamp: 'je 1/18/2008 18:21'!
doesNotUnderstand: aMessage
	^self meta send send: aMessage for: self! !

!CodAAnonymClass methodsFor: 'accessing' stamp: 'mab 1/18/2008 16:18'!
meta
	^ meta! !

!CodAAnonymClass methodsFor: 'accessing' stamp: 'mab 1/18/2008 16:18'!
meta: anObject
	meta := anObject! !

!CodAAnonymClass methodsFor: 'as yet unclassified' stamp: 'je 1/18/2008 19:27'!
species
	^self baseClass! !

!CodAAnonymClass methodsFor: 'as yet unclassified' stamp: 'mab 1/22/2008 11:24'!
withArgs: argArray executeMethod: compiledMethod
	"Execute compiledMethod against the receiver and args in argArray"

	| selector |
	<primitive: 188>
	selector := Symbol new.
	self class addSelectorSilently: selector withMethod: compiledMethod.
	^ [self perform: selector withArguments: argArray]
		ensure: [self class basicRemoveSelector: selector]! !

Object subclass: #CodAMeta
	instanceVariableNames: 'anonymClass oldObject metaComponents'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodA-Kernel'!

!CodAMeta class methodsFor: 'as yet unclassified' stamp: 'je 1/18/2008 18:24'!
standardComponent
	^CodAMetaStandardComponent! !

!CodAMeta class methodsFor: 'as yet unclassified' stamp: 'mab 1/18/2008 15:34'!
with: anonymClass
	^self new anonymClass: anonymClass! !

!CodAMeta methodsFor: 'accessing' stamp: 'mab 11/8/2007 17:13'!
accept
	^ self componentAt: #Accept! !

!CodAMeta methodsFor: 'accessing' stamp: 'mab 1/18/2008 15:35'!
anonymClass
	^ anonymClass! !

!CodAMeta methodsFor: 'accessing' stamp: 'mab 1/18/2008 15:35'!
anonymClass: anObject
	anonymClass := anObject! !

!CodAMeta methodsFor: 'as yet unclassified' stamp: 'mab 11/8/2007 16:12'!
asExtendableMetaFor: anObject
	^self! !

!CodAMeta methodsFor: 'as yet unclassified' stamp: 'mab 11/8/2007 17:12'!
componentAt: aSelector
	^ metaComponents at: aSelector! !

!CodAMeta methodsFor: 'as yet unclassified' stamp: 'mab 11/8/2007 17:12'!
componentAt: aSelector put: aComponent
	^ metaComponents at: aSelector put: aComponent! !

!CodAMeta methodsFor: 'accessing' stamp: 'mab 11/8/2007 17:14'!
configuration
	^ self componentAt: #Configuration! !

!CodAMeta methodsFor: 'accessing' stamp: 'mab 11/8/2007 17:13'!
execution
	^ self componentAt: #Execution! !

!CodAMeta methodsFor: 'as yet unclassified' stamp: 'mab 1/18/2008 15:52'!
initialize
	metaComponents := Dictionary new.
	self componentAt: #Protocol put: self class standardComponent.
	self componentAt: #State put: self class standardComponent.
	self componentAt: #Accept put: self class standardComponent.
	self componentAt: #Send put: self class standardComponent.
	self componentAt: #Receive put: self class standardComponent.
	self componentAt: #Execution put: self class standardComponent.
	self componentAt: #Queue put: self class standardComponent.! !

!CodAMeta methodsFor: 'as yet unclassified' stamp: 'je 1/25/2008 17:01'!
install: aComponent at: aSymbol for: anObject
	self componentAt:  aSymbol put: aComponent.
	aComponent installingOn: aSymbol for: anObject! !

!CodAMeta methodsFor: 'as yet unclassified' stamp: 'mab 11/8/2007 16:16'!
isExtendableMeta
	^true! !

!CodAMeta methodsFor: 'accessing' stamp: 'je 1/18/2008 18:25'!
oldObject
	^ oldObject! !

!CodAMeta methodsFor: 'accessing' stamp: 'je 1/18/2008 18:25'!
oldObject: anObject
	oldObject := anObject! !

!CodAMeta methodsFor: 'accessing' stamp: 'mab 11/8/2007 17:13'!
protocol
	^ self componentAt: #Protocol! !

!CodAMeta methodsFor: 'accessing' stamp: 'mab 11/8/2007 17:13'!
queue
	^ self componentAt: #Queue! !

!CodAMeta methodsFor: 'accessing' stamp: 'mab 11/8/2007 17:13'!
receive
	^ self componentAt: #Receive! !

!CodAMeta methodsFor: 'accessing' stamp: 'mab 11/8/2007 17:13'!
send
	^ self componentAt: #Send! !

!CodAMeta methodsFor: 'accessing' stamp: 'mab 11/8/2007 17:12'!
state
	^ self componentAt: #State! !

Object subclass: #CodAMetaComponent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodA-Kernel'!

CodAMetaComponent subclass: #CodAMetaStandardComponent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodA-Kernel'!

!CodAMetaStandardComponent class methodsFor: 'as yet unclassified' stamp: 'mab 1/22/2008 11:29'!
methodFor: aMessage for: anObject
	^anObject meta oldObject class allCompiledMethodsAt: aMessage selector! !

!CodAMetaStandardComponent class methodsFor: 'as yet unclassified' stamp: 'mab 1/25/2008 16:28'!
send: aMessage for: anObject
	| method |
	method := anObject meta protocol methodFor: aMessage for: anObject.
	method isPrimitive ifTrue: [ 
		^ method 
			valueWithReceiver: anObject meta oldObject 
			arguments: aMessage arguments] ifFalse: [ 
		^method 
			valueWithReceiver: anObject 
			arguments: aMessage arguments].! !

Object subclass: #M
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodA-Kernel'!

!M class methodsFor: 'as yet unclassified' stamp: 'mab 12/5/2007 14:38'!
b
	^ CodAMessageBuilder new! !

!Object methodsFor: '*CodA' stamp: 'mab 12/5/2007 14:59'!
!!!! aMessage
	^ self meta send sendAsync: aMessage for: self! !

!Object methodsFor: '*CodA' stamp: 'mab 12/5/2007 14:57'!
<!! aMessage
	^ self meta send sendFuture: aMessage for: self! !

!Object methodsFor: '*CodA' stamp: 'mab 12/5/2007 15:00'!
<* aMessage
	^ self meta send send: aMessage for: self! !

!Object methodsFor: '*CodA' stamp: 'mab 12/5/2007 14:49'!
<> aMessage
	^ self meta send sendSync: aMessage for: self! !

!Object methodsFor: '*CodA' stamp: 'je 1/25/2008 17:48'!
hasExtendableMeta
	^self meta isExtendableMeta! !

!Object methodsFor: '*CodA' stamp: 'je 1/25/2008 17:48'!
meta
	^self class! !

!Object methodsFor: '*CodA' stamp: 'je 1/25/2008 17:57'!
withExtendableMeta
	self hasExtendableMeta ifFalse: [
		^self class asExtendableMetaFor: self]
	ifTrue: [^self meta]! !

ProtoObject subclass: #CodAMessageAccumulator
	instanceVariableNames: 'messageChain'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodA-Kernel'!

!CodAMessageAccumulator class methodsFor: 'as yet unclassified' stamp: 'mab 12/5/2007 15:06'!
with: aMessageChain
	^self new instVarAt: #messageChain put: aMessageChain! !

!CodAMessageAccumulator methodsFor: 'as yet unclassified' stamp: 'mab 12/5/2007 15:05'!
doesNotUnderstand: message
	^ CodAMessageAccumulator with: (messageChain ifNil: [OrderedCollection new]), message! !

!CodAMessageAccumulator methodsFor: 'as yet unclassified' stamp: 'mab 12/5/2007 15:08'!
m
	^ messageChain! !

ProtoObject subclass: #CodAMessageBuilder
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodA-Kernel'!

!CodAMessageBuilder methodsFor: 'as yet unclassified' stamp: 'mab 12/5/2007 14:33'!
doesNotUnderstand: message
	^ message
	! !

!Class methodsFor: '*CodA' stamp: 'mab 1/22/2008 11:26'!
asExtendableMetaFor: anObject 
	| anonymClass codAMeta newObject |
	anonymClass := ClassBuilder new
				newAnonymSubclassOf: ProtoObject
				type: ProtoObject typeOfClass
				instanceVariables: (Set withAll: CodAAnonymClass instVarNames)
				from: nil.
	CodAAnonymClass class instVarNames do: [ :instVarName |
		anonymClass class addInstVarName: instVarName ].
	CodAAnonymClass class selectorsDo: [:selector |
		anonymClass class compile: (CodAAnonymClass class ultimateSourceCodeAt: selector ifAbsent: [])].
	CodAAnonymClass selectorsDo: [ :selector |
		anonymClass compile: (CodAAnonymClass ultimateSourceCodeAt: selector ifAbsent: [])].
	codAMeta := CodAMeta with: anonymClass.
	codAMeta oldObject: anObject veryDeepCopy.
	newObject := anonymClass new.
	newObject meta: codAMeta.
	newObject baseClass: anObject class.
	anonymClass meta: codAMeta.
	anObject become: newObject.
	^codAMeta! !

!Class methodsFor: '*CodA' stamp: 'mab 11/8/2007 16:14'!
isExtendableMeta
	^false! !

!CompiledMethod methodsFor: '*CodA' stamp: 'mab 1/25/2008 16:25'!
isPrimitive
	^ self primitive ~= 0! !

TestCase subclass: #CodaTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodA-Tests'!

!CodaTests methodsFor: 'as yet unclassified' stamp: 'mab 11/20/2007 11:14'!
testClassStaysTheSameAfterCreatingExtendableMeta
	| instance |
	instance := Object new.
	instance meta asExtendableMetaFor: instance.
	self assert: instance class == Object.! !

!CodaTests methodsFor: 'as yet unclassified' stamp: 'mab 11/20/2007 11:10'!
testInstanceStaysTheSameAfterCreatingExtendableMeta
	| instance oldInstance |
	instance := oldInstance := Object new.
	instance meta asExtendableMetaFor: instance.
	self assert: instance == oldInstance.! !

!CodaTests methodsFor: 'as yet unclassified' stamp: 'mab 12/5/2007 14:41'!
testMessageBuilderBuildsCorrectMessage
	| message |
	message := M b at: 1 put: 68.
	self assert: message arguments = #(1 68).
	self assert: message selector = #at:put:.! !

!CodaTests methodsFor: 'as yet unclassified' stamp: 'je 1/25/2008 17:54'!
testSend
	| anObject |
	anObject := Object new.
	anObject withExtendableMeta.
	self shouldnt: [anObject name] raise: Error.! !

!CodaTests methodsFor: 'as yet unclassified' stamp: 'je 12/5/2007 16:19'!
testSubclassesAmountStaysTheSameAfterCreatingExtendableMeta
	| instance countBefore |
	countBefore := Object subclasses size.
	instance := Object new.
	instance meta asExtendableMetaFor: instance.
	self assert: countBefore == Object subclasses size.! !
